StarObjectSmallGraphic Class Reference

the main class to read a small StarOffice graphic zone More...

`#include <StarObjectSmallGraphic.hxx>`

Inheritance diagram for StarObjectSmallGraphic:

## Public Member Functions

| StarObjectSmallGraphic (StarObject const &orig, bool duplicateState)
| constructor
| ~StarObjectSmallGraphic () override
| destructor
bool | readSdrObject (StarZone &zone)
| try to read a object zone: "DrOb'
bool | send (STOFFListenerPtr &listener, STOFFFrameStyle const &pos, StarObject &object, bool inPageMaster=false)
| try to send a object to the listener
Public Member Functions inherited from StarObject
| StarObject (char const *passwd, std::shared_ptr< STOFFOLEParser > &oleParser, std::shared_ptr< STOFFOLEParser::OleDirectory > &directory)
| constructor
virtual | ~StarObject ()
| destructor
bool | parse ()
| try to parse data
STOFFDocument::Kind | getDocumentKind () const
| returns the document kind
char const * | getPassword () const
| returns the document password (the password given by the user)
std::shared_ptr< STOFFOLEParser::OleDirectory > | getOLEDirectory ()
| returns the object directory
std::shared_ptr< StarAttributeManager > | getAttributeManager ()
| returns the attribute manager
std::shared_ptr< StarFormatManager > | getFormatManager ()
| returns the format manager
librevenge::RVNGPropertyList const & | getMetaData () const
| returns the meta data (filled by readSfxDocumentInformation)
librevenge::RVNGString | getUserNameMetaData (int i) const
| returns the ith user meta data
void | cleanPools ()
| clean each pool
std::shared_ptr< StarItemPool > | getNewItemPool (StarItemPool::Type type)
| returns a new item pool for this document
std::shared_ptr< StarItemPool > | findItemPool (StarItemPool::Type type, bool isInside)
| check if a pool corresponding to a given type is opened if so returned it.
std::shared_ptr< StarItemPool > | getCurrentPool (bool onlyInside=true)
| returns the current all/inside pool
bool | readPersistData (StarZone &zone, long endPos)
| try to read persist data
bool | readSfxStyleSheets (STOFFInputStreamPtr input, std::string const &name)
| try to read a spreadshet style zone: SfxStyleSheets
bool | readItemSet (StarZone &zone, std::vector< STOFFVec2i > const &limits, long endPos, StarItemSet &itemSet, StarItemPool *pool=nullptr, bool isDirect=false)
| try to read a list of item

## Protected Member Functions

std::shared_ptr< StarObjectSmallGraphicInternal::SdrGraphic > | readSVDRObject (StarZone &zone, int identifier)
| try to read a SVDr object
bool | readSVDRObjectHeader (StarZone &zone, StarObjectSmallGraphicInternal::SdrGraphic &graphic)
| try to read the first zone of SVDr object
bool | readSVDRObjectAttrib (StarZone &zone, StarObjectSmallGraphicInternal::SdrGraphicAttribute &graphic)
| try to read the object attrib zone
bool | readSVDRObjectText (StarZone &zone, StarObjectSmallGraphicInternal::SdrGraphicText &graphic)
| try to read the object text zone
bool | readSVDRObjectRect (StarZone &zone, StarObjectSmallGraphicInternal::SdrGraphicRect &graphic)
| try to read the object rect zone
bool | readSVDRObjectCaption (StarZone &zone, StarObjectSmallGraphicInternal::SdrGraphicCaption &graphic)
| try to read the object caption zone
bool | readSVDRObjectCircle (StarZone &zone, StarObjectSmallGraphicInternal::SdrGraphicCircle &graphic)
| try to read the object circle zone
bool | readSVDRObjectEdge (StarZone &zone, StarObjectSmallGraphicInternal::SdrGraphicEdge &graphic)
| try to read the object edge zone
bool | readSVDRObjectGraph (StarZone &zone, StarObjectSmallGraphicInternal::SdrGraphicGraph &graphic)
| try to read the object graph zone
bool | readSVDRObjectGroup (StarZone &zone, StarObjectSmallGraphicInternal::SdrGraphicGroup &graphic)
| try to read the object group zone
bool | readSVDRObjectMeasure (StarZone &zone, StarObjectSmallGraphicInternal::SdrGraphicMeasure &graphic)
| try to read the object measure zone
bool | readSVDRObjectOLE (StarZone &zone, StarObjectSmallGraphicInternal::SdrGraphicOLE &graphic)
| try to read the object OLE zone
bool | readSVDRObjectPath (StarZone &zone, StarObjectSmallGraphicInternal::SdrGraphicPath &graphic)
| try to read the object path zone
bool | readSDRGluePoint (StarZone &zone, StarObjectSmallGraphicInternal::GluePoint &point)
| try to read a SDR gluepoint
bool | readSDRGluePointList (StarZone &zone, std::vector< StarObjectSmallGraphicInternal::GluePoint > &listPoints)
| try to read a SDR gluepoint list
bool | readSDRObjectConnection (StarZone &zone)
| try to read a SDR object connection
bool | readSDRObjectSurrogate (StarZone &zone)
| try to read a SDR object surrogate
bool | readSDROutlinerParaObject (StarZone &zone, StarObjectSmallGraphicInternal::OutlinerParaObject &object)
| try to read a outliner para object
std::shared_ptr< StarObjectSmallGraphicInternal::SDRUserData > | readSDRUserData (StarZone &zone, bool inRecord)
| try to read a SDR userData
bool | readSDRUserDataList (StarZone &zone, bool inRecord, std::vector< std::shared_ptr< StarObjectSmallGraphicInternal::SDRUserData > > &data)
| try to read a SDR userData list
std::shared_ptr< StarObjectSmallGraphicInternal::Graphic > | readFmFormObject (StarZone &zone, int identifier)
| try to read a FM01 object
std::shared_ptr< StarObjectSmallGraphicInternal::SDRUserData > | readSCHUObject (StarZone &zone, int identifier)
| try to read a SCHU object
std::shared_ptr< StarObjectSmallGraphicInternal::SDRUserData > | readSDUDObject (StarZone &zone, int identifier)
| try to read a SDDU object
Protected Member Functions inherited from StarObject
bool | readPersistElements (STOFFInputStreamPtr input, std::string const &name)
| the "persist elements" small ole: the list of object
bool | readSfxDocumentInformation (STOFFInputStreamPtr input, std::string const &name)
| try to read the document information : "SfxDocumentInformation"
bool | readSfxPreview (STOFFInputStreamPtr input, std::string const &name)
| try to read the preview : "SfxPreview"
bool | readSfxWindows (STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read the windows information : "SfxWindows"
bool | readStarFrameworkConfigFile (STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read the "Star Framework Config File"
bool | readStarFrameworkConfigItem (STOFFEntry &entry, STOFFInputStreamPtr input, libstoff::DebugFile &ascii)
| try to read an item in a "Star Framework Config File"
| StarObject (StarObject const &orig, bool duplicateState)
| copy constructor

## Protected Attributes

std::shared_ptr< StarObjectSmallGraphicInternal::State > | m_graphicState
| the state
Protected Attributes inherited from StarObject
char const * | m_password
| the document password
std::shared_ptr< STOFFOLEParser > | m_oleParser
| the ole parser
std::shared_ptr< STOFFOLEParser::OleDirectory > | m_directory
| the directory
std::shared_ptr< StarObjectInternal::State > | m_state
| the state
librevenge::RVNGPropertyList | m_metaData
| the meta data

## Private Member Functions

StarObjectSmallGraphic & | operator= (StarObjectSmallGraphic const &orig)=delete

## Friends

std::ostream & | operator<< (std::ostream &o, StarObjectSmallGraphic const &graphic)
| small operator<< to print the content of the small graphic object

## Detailed Description

the main class to read a small StarOffice graphic zone

## Constructor & Destructor Documentation

## StarObjectSmallGraphic()

StarObjectSmallGraphic::StarObjectSmallGraphic | ( | StarObject const & | orig,
|  | bool | duplicateState )

constructor

Referenced by operator<<, operator=(), and readSVDRObjectGroup().

## ~StarObjectSmallGraphic()

StarObjectSmallGraphic::~StarObjectSmallGraphic | ( |  | ) |

override

destructor

## Member Function Documentation

## operator=()

StarObjectSmallGraphic & StarObjectSmallGraphic::operator= | ( | StarObjectSmallGraphic const & | orig | ) |

private delete

## readFmFormObject()

std::shared_ptr< StarObjectSmallGraphicInternal::Graphic > StarObjectSmallGraphic::readFmFormObject | ( | StarZone & | zone,
|  | int | identifier )

protected

try to read a FM01 object

Referenced by readSdrObject().

## readSCHUObject()

std::shared_ptr< StarObjectSmallGraphicInternal::SDRUserData > StarObjectSmallGraphic::readSCHUObject | ( | StarZone & | zone,
|  | int | identifier )

protected

try to read a SCHU object

Referenced by readSdrObject(), and readSDRUserData().

## readSDRGluePoint()

bool StarObjectSmallGraphic::readSDRGluePoint | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::GluePoint & | point )

protected

try to read a SDR gluepoint

Referenced by readSDRGluePointList().

## readSDRGluePointList()

bool StarObjectSmallGraphic::readSDRGluePointList | ( | StarZone & | zone,
|  | std::vector< StarObjectSmallGraphicInternal::GluePoint > & | listPoints )

protected

try to read a SDR gluepoint list

Referenced by readSVDRObjectHeader().

## readSdrObject()

bool StarObjectSmallGraphic::readSdrObject | ( | StarZone & | zone | ) |

try to read a object zone: "DrOb'

## readSDRObjectConnection()

bool StarObjectSmallGraphic::readSDRObjectConnection | ( | StarZone & | zone | ) |

protected

try to read a SDR object connection

Referenced by readSVDRObjectEdge().

## readSDRObjectSurrogate()

bool StarObjectSmallGraphic::readSDRObjectSurrogate | ( | StarZone & | zone | ) |

protected

try to read a SDR object surrogate

Referenced by readSDRObjectConnection(), and readSDUDObject().

## readSDROutlinerParaObject()

bool StarObjectSmallGraphic::readSDROutlinerParaObject | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::OutlinerParaObject & | object )

protected

try to read a outliner para object

Referenced by readSVDRObjectText().

## readSDRUserData()

std::shared_ptr< StarObjectSmallGraphicInternal::SDRUserData > StarObjectSmallGraphic::readSDRUserData | ( | StarZone & | zone,
|  | bool | inRecord )

protected

try to read a SDR userData

Referenced by readSDRUserDataList().

## readSDRUserDataList()

bool StarObjectSmallGraphic::readSDRUserDataList | ( | StarZone & | zone,
|  | bool | inRecord,
|  | std::vector< std::shared_ptr< StarObjectSmallGraphicInternal::SDRUserData > > & | data )

protected

try to read a SDR userData list

Referenced by readSVDRObjectHeader().

## readSDUDObject()

std::shared_ptr< StarObjectSmallGraphicInternal::SDRUserData > StarObjectSmallGraphic::readSDUDObject | ( | StarZone & | zone,
|  | int | identifier )

protected

try to read a SDDU object

Referenced by readSDRUserData().

## readSVDRObject()

std::shared_ptr< StarObjectSmallGraphicInternal::SdrGraphic > StarObjectSmallGraphic::readSVDRObject | ( | StarZone & | zone,
|  | int | identifier )

protected

try to read a SVDr object

Referenced by readSdrObject().

## readSVDRObjectAttrib()

bool StarObjectSmallGraphic::readSVDRObjectAttrib | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::SdrGraphicAttribute & | graphic )

protected

try to read the object attrib zone

Referenced by readSVDRObjectText().

## readSVDRObjectCaption()

bool StarObjectSmallGraphic::readSVDRObjectCaption | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::SdrGraphicCaption & | graphic )

protected

try to read the object caption zone

Referenced by readSVDRObject().

## readSVDRObjectCircle()

bool StarObjectSmallGraphic::readSVDRObjectCircle | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::SdrGraphicCircle & | graphic )

protected

try to read the object circle zone

Referenced by readSVDRObject().

## readSVDRObjectEdge()

bool StarObjectSmallGraphic::readSVDRObjectEdge | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::SdrGraphicEdge & | graphic )

protected

try to read the object edge zone

Referenced by readSVDRObject().

## readSVDRObjectGraph()

bool StarObjectSmallGraphic::readSVDRObjectGraph | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::SdrGraphicGraph & | graphic )

protected

try to read the object graph zone

Referenced by readSVDRObject().

## readSVDRObjectGroup()

bool StarObjectSmallGraphic::readSVDRObjectGroup | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::SdrGraphicGroup & | graphic )

protected

try to read the object group zone

Referenced by readSCHUObject(), and readSVDRObject().

## readSVDRObjectHeader()

bool StarObjectSmallGraphic::readSVDRObjectHeader | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::SdrGraphic & | graphic )

protected

try to read the first zone of SVDr object

Referenced by readSVDRObject(), readSVDRObjectAttrib(), and readSVDRObjectGroup().

## readSVDRObjectMeasure()

bool StarObjectSmallGraphic::readSVDRObjectMeasure | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::SdrGraphicMeasure & | graphic )

protected

try to read the object measure zone

Referenced by readSVDRObject().

## readSVDRObjectOLE()

bool StarObjectSmallGraphic::readSVDRObjectOLE | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::SdrGraphicOLE & | graphic )

protected

try to read the object OLE zone

Referenced by readSVDRObject().

## readSVDRObjectPath()

bool StarObjectSmallGraphic::readSVDRObjectPath | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::SdrGraphicPath & | graphic )

protected

try to read the object path zone

Referenced by readSVDRObject().

## readSVDRObjectRect()

bool StarObjectSmallGraphic::readSVDRObjectRect | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::SdrGraphicRect & | graphic )

protected

try to read the object rect zone

Referenced by readFmFormObject(), readSVDRObject(), readSVDRObjectCaption(), readSVDRObjectCircle(), readSVDRObjectGraph(), and readSVDRObjectOLE().

## readSVDRObjectText()

bool StarObjectSmallGraphic::readSVDRObjectText | ( | StarZone & | zone,
|  | StarObjectSmallGraphicInternal::SdrGraphicText & | graphic )

protected

try to read the object text zone

Referenced by readSVDRObjectEdge(), readSVDRObjectMeasure(), readSVDRObjectPath(), and readSVDRObjectRect().

## send()

bool StarObjectSmallGraphic::send | ( | STOFFListenerPtr & | listener,
|  | STOFFFrameStyle const & | pos,
|  | StarObject & | object,
|  | bool | inPageMaster = false )

try to send a object to the listener

## Friends And Related Symbol Documentation

## operator<<

std::ostream & operator<< | ( | std::ostream & | o,
|  | StarObjectSmallGraphic const & | graphic )

friend

small operator<< to print the content of the small graphic object

## Member Data Documentation

## m_graphicState

std::shared_ptr<StarObjectSmallGraphicInternal::State> StarObjectSmallGraphic::m_graphicState

protected

the state

Referenced by operator<<, readSdrObject(), send(), and StarObjectSmallGraphic().

The documentation for this class was generated from the following files:

- StarObjectSmallGraphic.hxx
- StarObjectSmallGraphic.cxx